# Record Class CATypeScalarType.Real

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CATypeScalarType.Real

Record Components:
  `name` - The type name
  `description` - A humanly-readable description of the type
  `rangeLower` - The lower bound (inclusive)
  `rangeUpper` - The upper bound (inclusive)

All Implemented Interfaces:
  `CATypeScalarType`

Enclosing interface:
  `CATypeScalarType`

public static record CATypeScalarType.Real(CATypeScalarIdentifier name, String description, double rangeLower, double rangeUpper) extends Record implements CATypeScalarType
A real type.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface com.io7m.cardant.model.CATypeScalarType

  `CATypeScalarType.Integral, CATypeScalarType.Kind, CATypeScalarType.Monetary, CATypeScalarType.Real, CATypeScalarType.Text, CATypeScalarType.Time`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Real(CATypeScalarIdentifier name, String description, double rangeLower, double rangeUpper)`
  A real type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `boolean`
  `isValid(double value)`
  `CATypeScalarType.Kind`
  `kind()`
  `CATypeScalarIdentifier`
  `name()`
  Returns the value of the `name` record component.
  `double`
  `rangeLower()`
  Returns the value of the `rangeLower` record component.
  `double`
  `rangeUpper()`
  Returns the value of the `rangeUpper` record component.
  `String`
  `showConstraint()`
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `CATypeScalarType`
  `withName(CATypeScalarIdentifier newName)`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Real

    public Real(CATypeScalarIdentifier name, String description, double rangeLower, double rangeUpper)
    A real type.
    Parameters:
      `name` - The type name
      `description` - A humanly-readable description of the type
      `rangeLower` - The lower bound (inclusive)
      `rangeUpper` - The upper bound (inclusive)

- ## Method Details

  - ### withName

    public CATypeScalarType withName(CATypeScalarIdentifier newName)
    Specified by:
      `withName` in interface `CATypeScalarType`
    Parameters:
      `newName` - The new name
    Returns:
      This type with a new name

  - ### showConstraint

    public String showConstraint()
    Specified by:
      `showConstraint` in interface `CATypeScalarType`
    Returns:
      A humanly-readable description of this type's value constraints

  - ### kind

    public CATypeScalarType.Kind kind()
    Specified by:
      `kind` in interface `CATypeScalarType`
    Returns:
      The internal type kind

  - ### isValid

    public boolean isValid(double value)
    Parameters:
      `value` - The value
    Returns:
      `true` if the given value is in the range for this type

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public CATypeScalarIdentifier name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `CATypeScalarType`
    Returns:
      the value of the `name` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Specified by:
      `description` in interface `CATypeScalarType`
    Returns:
      the value of the `description` record component

  - ### rangeLower

    public double rangeLower()
    Returns the value of the `rangeLower` record component.
    Returns:
      the value of the `rangeLower` record component

  - ### rangeUpper

    public double rangeUpper()
    Returns the value of the `rangeUpper` record component.
    Returns:
      the value of the `rangeUpper` record component